Codeforces Round #367 (Div. 2)

来源:互联网 发布:java两个时间相减 编辑:程序博客网 时间:2024/05/23 16:53
                                                                                                                                    A. Beru-taxi
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Vasiliy lives at point (a, b) of the coordinate plane. He is hurrying up to work so he wants to get out of his house as soon as possible. New app suggestedn available Beru-taxi nearby. The i-th taxi is located at point (xi, yi) and moves with a speedvi.

Consider that each of n drivers will move directly to Vasiliy and with a maximum possible speed. Compute the minimum time when Vasiliy will get in any of Beru-taxi cars.

Input

The first line of the input contains two integersa and b ( - 100 ≤ a, b ≤ 100) — coordinates of Vasiliy's home.

The second line contains a single integer n (1 ≤ n ≤ 1000) — the number of available Beru-taxi cars nearby.

The i-th of the followingn lines contains three integers xi, yi and vi ( - 100 ≤ xi, yi ≤ 100,1 ≤ vi ≤ 100) — the coordinates of thei-th car and its speed.

It's allowed that several cars are located at the same point. Also, cars may be located at exactly the same point where Vasiliy lives.

Output

Print a single real value — the minimum time Vasiliy needs to get in any of the Beru-taxi cars. You answer will be considered correct if its absolute or relative error does not exceed10 - 6.

Namely: let's assume that your answer is a, and the answer of the jury is b. The checker program will consider your answer correct, if.

Examples
Input
0 022 0 10 2 2
Output
1.00000000000000000000
Input
1 333 3 2-2 3 6-2 7 10
Output
0.50000000000000000000
Note

In the first sample, first taxi will get to Vasiliy in time2, and second will do this in time 1, therefore 1 is the answer.

In the second sample, cars 2 and 3 will arrive simultaneously.


题意:求出所以租车到人该位置最短时间。


<span style="font-size:18px;">#include<iostream>#include<cstring>#include<cstdio>#include<algorithm>#include<cmath>#define eps 1e-7using namespace std;const int maxn=1010;struct node{   double x,y,t,dis,v;}nod[maxn];int main(){    double x,y;    int n;    while(~scanf("%lf %lf",&x,&y))    {        memset(nod,0,sizeof(nod));        double a,b;        double sum=100000000;        scanf("%d",&n);        for(int i=0;i<n;i++){            scanf("%lf %lf %lf",&nod[i].x,&nod[i].y,&nod[i].v);            nod[i].t=sqrt((nod[i].x-x)*(nod[i].x-x)+(nod[i].y-y)*(nod[i].y-y))/nod[i].v;            //cout << nod[i].t <<endl;            if(sum-nod[i].t>eps) sum=nod[i].t;        }        printf("%f\n",sum);    }    return 0;}</span>

                                                                                                        

                                                                                                                                  B. Interesting drink
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Vasiliy likes to rest after a hard work, so you may often meet him in some bar nearby. As all programmers do, he loves the famous drink "Beecola", which can be bought inn different shops in the city. It's known that the price of one bottle in the shopi is equal to xi coins.

Vasiliy plans to buy his favorite drink for q consecutive days. He knows, that on the i-th day he will be able to spent mi coins. Now, for each of the days he want to know in how many different shops he can buy a bottle of "Beecola".

Input

The first line of the input contains a single integern (1 ≤ n ≤ 100 000) — the number of shops in the city that sell Vasiliy's favourite drink.

The second line contains n integersxi (1 ≤ xi ≤ 100 000) — prices of the bottles of the drink in thei-th shop.

The third line contains a single integer q (1 ≤ q ≤ 100 000) — the number of days Vasiliy plans to buy the drink.

Then follow q lines each containing one integermi (1 ≤ mi ≤ 109) — the number of coins Vasiliy can spent on thei-th day.

Output

Print q integers. Thei-th of them should be equal to the number of shops where Vasiliy will be able to buy a bottle of the drink on thei-th day.

Example
Input
53 10 8 6 114110311
Output
0415
Note

On the first day, Vasiliy won't be able to buy a drink in any of the shops.

On the second day, Vasiliy can buy a drink in the shops1, 2, 3 and 4.

On the third day, Vasiliy can buy a drink only in the shop number1.

Finally, on the last day Vasiliy can buy a drink in any shop.


题意:求数组大于给定数x的个数。


解题思路:只要将数组小到大排序,然后二分查找第一个大于x的位置(由于数组从0开始),所以得到的位置就是满足条件数的个数。


<span style="font-size:18px;">#include<iostream>#include<cstdio>#include<algorithm>#include<cmath>#include<vector>#include<cstring>using namespace std;const int maxn=100010;int a[maxn];int main(){    int n;    while(~scanf("%d",&n))    {        for(int i=0;i<n;i++){            scanf("%d",&a[i]);        }        sort(a,a+n);        int q,x;        scanf("%d",&q);        for(int i=0;i<q;i++){            scanf("%d",&x);            int sum=upper_bound(a,a+n,x) - a;            printf("%d\n",sum);        }    }    return 0;}</span>


C. Hard problem
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Vasiliy is fond of solving different tasks. Today he found one he wasn't able to solve himself, so he asks you to help.

Vasiliy is given n strings consisting of lowercase English letters. He wants them to be sorted in lexicographical order (as in the dictionary), but he is not allowed to swap any of them. The only operation he is allowed to do is to reverse any of them (first character becomes last, second becomes one before last and so on).

To reverse the i-th string Vasiliy has to spentci units of energy. He is interested in the minimum amount of energy he has to spent in order to have strings sorted in lexicographical order.

String A is lexicographically smaller than stringB if it is shorter than B (|A| < |B|) and is its prefix, or if none of them is a prefix of the other and at the first position where they differ character inA is smaller than the character in B.

For the purpose of this problem, two equal strings nearby do not break the condition of sequence being sorted lexicographically.

Input

The first line of the input contains a single integern (2 ≤ n ≤ 100 000) — the number of strings.

The second line contains n integersci (0 ≤ ci ≤ 109), thei-th of them is equal to the amount of energy Vasiliy has to spent in order to reverse thei-th string.

Then follow n lines, each containing a string consisting of lowercase English letters. The total length of these strings doesn't exceed100 000.

Output

If it is impossible to reverse some of the strings such that they will be located in lexicographical order, print - 1. Otherwise, print the minimum total amount of energy Vasiliy has to spent.

Examples
Input
21 2baac
Output
1
Input
31 3 1aabaac
Output
1
Input
25 5bbbaaa
Output
-1
Input
23 3aaaaa
Output
-1
Note

In the second sample one has to reverse string 2 or string 3. To amount of energy required to reverse the string3 is smaller.

In the third sample, both strings do not change after reverse and they go in the wrong order, so the answer is - 1.

In the fourth sample, both strings consists of characters 'a' only, but in the sorted order string "aa" should go before string "aaa", thus the answer is  - 1.


题意:给你n个字符串,每个字符串可以倒过来(需要花费a[i[),问你是这n个字符串能否变成字典序排序(每个字符串可以倒过来,也可以为原状态),如果不行输出-1,否则输出费用最小值。


解题思路:一开始觉得就是模拟题,后来错了,然后比赛快结束推出了dp状态转移方程,不过来不及了。

每个字符串只有两种状态,假设S[i]为未反转的状态,s1[i]为反转过来的状态,dp[i][s]---->dp[i][0]表示第 i 个字符串未转换过来前 i 串得到的最优解,dp[i][1]表示第 i 个字符串反转过来前 i 串得到的最优解,那么状态转移方程为:

                        dp[i][0]=dp[i-1][0] (s[i]>=s[i-1])

                       dp[i][0]=dp[i-1][1]  (s[i]>=s1[i-1])

                       dp[i][1]=dp[i-1][0]+a[i] (s[i]>=s[i-1])

                        dp[i][1]=dp[i-1][1]+a[i] (s[i]>=s1[i-1])


<span style="font-size:18px;">#include<iostream>#include<cstdio>#include<algorithm>#include<cmath>#include<vector>#include<cstring>#define inf 1e16using namespace std;string s[100010];string s1[100010];long long dp[100010][2];int a[100010];int main(){    int n;    while(~scanf("%d",&n)){        for(int i=1;i<=n;i++) scanf("%d",&a[i]);        for(int i=0;i<=n+1;i++) dp[i][0]=dp[i][1]=inf;        for(int i=1;i<=n;i++){            cin>>s[i];            int len=s[i].size();            //cout << len << endl;            for(int j=0,k=len-1;k>=0;k--,j++){                s1[i]+=s[i][k];            }        }        dp[1][0]=0;        dp[1][1]=a[1];        for(int i=2;i<=n;i++){            int ans=0;            if(s[i]>=s[i-1]){                dp[i][0]=min(dp[i][0],dp[i-1][0]);            }//else ans++;            if(s[i]>=s1[i-1]){                dp[i][0]=min(dp[i][0],dp[i-1][1]);            }//else ans++;            if(s1[i]>=s[i-1]){                dp[i][1]=min(dp[i][1],dp[i-1][0]+a[i]);            }//else ans++;            if(s1[i]>=s1[i-1]){                dp[i][1]=min(dp[i][1],dp[i-1][1]+a[i]);            }//else ans++;            //if(ans==4) flag=0;        }        //if(flag==0){            //printf("-1\n");            //continue;        //}        printf("%I64d\n",((min(dp[n][0],dp[n][1]))==inf) ? -1 : min(dp[n][0],dp[n][1]));    }    return 0;}</span>


0 0
原创粉丝点击